require_relative '../app_generator'

module Betterdoc
  module Generators
    module Impl
      class ContainerserviceAppGenerator < Betterdoc::Generators::AppGenerator

        def create_servicefile
          servicefile = super
          servicefile.add_environment('JWT_PUBLIC_KEY', "The public key to decode the JWTs")
          servicefile.add_environment('JWT_VALIDATION_ALGORITHM', "The algorithm to be used to decode the JWTs", true, "RS256")
          servicefile
        end

        class ContainerserviceAppBuilder < Betterdoc::Generators::AppBuilder
          def gemfile
            template 'Gemfile-containerservice', 'Gemfile'
          end
        end

        def get_builder_class
          ContainerserviceAppBuilder
        end

      end
    end
  end
end
