require 'yaml'
require_relative 'servicefile_environment_entry'

module Betterdoc
  module Support
    class Servicefile

      attr_accessor :service_name
      attr_accessor :version
      attr_accessor :environment

      def initialize
        @version = "1.0"
        @environment = {}
      end

      def add_environment(variable_name, description, optional = false, default = nil)
        entry = ServicefileEnvironmentEntry.new
        entry.description = description
        entry.optional = optional
        entry.default = default
        @environment[variable_name] = entry
      end

      def to_yaml
        {
          'version' => '1.0',
          'service_name' => @app_name,
          'runtime' => {
            'env' => to_environment_hash
          }
        }.to_yaml
      end

      private

      def to_environment_hash
        environment = []
        @environment.each do |key, environment_entry|
          environment_item = { "name" => key }
          environment_item['description'] = environment_entry.description unless environment_entry.description.nil?
          environment_item['optional'] = true if environment_entry.optional
          environment_item['default'] = environment_entry.default unless environment_entry.default.nil?
          environment.push(environment_item)
        end
        environment
      end

    end
  end
end
